Index: src/Actions/FragmentationAction/FragmentationAutomationAction.def
===================================================================
--- src/Actions/FragmentationAction/FragmentationAutomationAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/FragmentationAction/FragmentationAutomationAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -11,12 +11,24 @@
 #include <vector>
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/STLVectorValidator.hpp"
+#include "Parameters/Validators/Specific/ParserFileValidator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::vector< boost::filesystem::path >)(std::string)(std::string)(std::string)(boost::filesystem::path)
 #define paramtokens ("fragment-jobs")("fragment-path")("server-address")("server-port")("fragment-executable")
 #define paramdescriptions ("vector of fragment files")("prefix of each fragment file")("hostname of server")("controller port of server")("executable to launch on clients")
-#define paramdefaults (NODEFAULT)(NODEFAULT)("127.0.0.1")("1026")(NODEFAULT)
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT("127.0.0.1"))(PARAM_DEFAULT("1026"))(NOPARAM_DEFAULT)
 #define paramreferences (jobfiles)(path)(host)(port)(executable)
+#define paramvalids \
+(STLVectorValidator< std::vector< boost::filesystem::path > >(ParserFileValidator() && FilePresentValidator())) \
+(DummyValidator< std::string >()) \
+(DummyValidator< std::string >()) \
+(DummyValidator< std::string >()) \
+(DummyValidator< boost::filesystem::path >())
 
 #undef statetypes
Index: src/Actions/GraphAction/CreateAdjacencyAction.def
===================================================================
--- src/Actions/GraphAction/CreateAdjacencyAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/GraphAction/CreateAdjacencyAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -17,4 +19,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #undef statetypes
Index: src/Actions/GraphAction/DepthFirstSearchAction.cpp
===================================================================
--- src/Actions/GraphAction/DepthFirstSearchAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/GraphAction/DepthFirstSearchAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -55,5 +55,5 @@
       LocalBackEdgeStack = new std::deque<bond *>; // no need to have it Subgraphs->Leaf->BondCount size
       DFS.PickLocalBackEdges(ListOfAtoms, LocalBackEdgeStack);
-      CyclicStructureAnalysis CycleAnalysis(params.DoSaturation ? DoSaturate : DontSaturate);
+      CyclicStructureAnalysis CycleAnalysis(params.DoSaturation.get() ? DoSaturate : DontSaturate);
       CycleAnalysis(LocalBackEdgeStack);
       delete(LocalBackEdgeStack);
Index: src/Actions/GraphAction/DepthFirstSearchAction.def
===================================================================
--- src/Actions/GraphAction/DepthFirstSearchAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/GraphAction/DepthFirstSearchAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,12 +9,16 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (bool)
 #define paramtokens ("DoSaturate")
 #define paramdescriptions ("whether to treat hydrogen special or not")
-#define paramdefaults ("1")
+#define paramdefaults (PARAM_DEFAULT(true))
 #define paramreferences (DoSaturation)
+#define paramvalids \
+(DummyValidator< bool >())
 
 #undef statetypes
Index: src/Actions/GraphAction/SubgraphDissectionAction.def
===================================================================
--- src/Actions/GraphAction/SubgraphDissectionAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/GraphAction/SubgraphDissectionAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #undef paramtypes
 #undef paramtokens
@@ -17,4 +19,5 @@
 #undef paramdefaults
 #undef paramreferences
+#undef paramvalids
 
 #define statetypes (MolAtomList)
Index: src/Actions/MoleculeAction/BondFileAction.cpp
===================================================================
--- src/Actions/MoleculeAction/BondFileAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/BondFileAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -43,10 +43,10 @@
   if(World::getInstance().countSelectedMolecules() == 1) {
     mol = World::getInstance().beginMoleculeSelection()->second;
-    LOG(0, "STATUS: Parsing bonds from " << params.bondfile
-        << ", skipping " << params.skiplines << "lines"
-        << ", adding " << params.id_offset << " to each id.");
-    ifstream input(params.bondfile.string().c_str());
+    LOG(0, "STATUS: Parsing bonds from " << params.bondfile.get()
+        << ", skipping " << params.skiplines.get() << "lines"
+        << ", adding " << params.id_offset.get() << " to each id.");
+    ifstream input(params.bondfile.get().string().c_str());
     World::AtomComposite Set = mol->getAtomSet();
-    World::getInstance().getBondGraph()->CreateAdjacencyListFromDbondFile(Set, &input, params.skiplines, params.id_offset);
+    World::getInstance().getBondGraph()->CreateAdjacencyListFromDbondFile(Set, &input, params.skiplines.get(), params.id_offset.get());
     input.close();
     mol->getBondCount();
Index: src/Actions/MoleculeAction/BondFileAction.def
===================================================================
--- src/Actions/MoleculeAction/BondFileAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/BondFileAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,12 +9,19 @@
 class MoleculeListClass;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (boost::filesystem::path)(int)(int)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (boost::filesystem::path)(unsigned int)(unsigned int)
 #define paramtokens ("bond-file")("skiplines")("offset")
 #define paramdescriptions ("name of the bond file")("number of header lines to skip")("offset to add to each id")
-#define paramdefaults (NODEFAULT)("1")("0")
+#define paramdefaults (NOPARAM_DEFAULT)(PARAM_DEFAULT(1))(PARAM_DEFAULT(0))
 #define paramreferences (bondfile)(skiplines)(id_offset)
+#define paramvalids \
+(FilePresentValidator()) \
+(DummyValidator< unsigned int >()) \
+(DummyValidator< unsigned int >())
 
 #undef statetypes
Index: src/Actions/MoleculeAction/ChangeNameAction.cpp
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/ChangeNameAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -40,5 +40,5 @@
     mol = World::getInstance().beginMoleculeSelection()->second;
     string oldName = mol->getName();
-    mol->setName(params.name);
+    mol->setName(params.name.get());
     return Action::state_ptr(new MoleculeChangeNameState(mol,params));
   } else
@@ -50,6 +50,6 @@
 
   string newName = state->mol->getName();
-  state->mol->setName(state->params.name);
-  state->params.name = newName;
+  state->mol->setName(state->params.name.get());
+  state->params.name.set(newName);
 
   return Action::state_ptr(_state);
Index: src/Actions/MoleculeAction/ChangeNameAction.def
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/ChangeNameAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,7 +9,9 @@
 class MoleculeListClass;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (std::string)
 #define paramtokens ("change-molname")
@@ -17,4 +19,6 @@
 #undef paramdefaults
 #define paramreferences (name)
+#define paramvalids \
+(DummyValidator< std::string >())
 
 #define statetypes (molecule*)
Index: src/Actions/MoleculeAction/CopyAction.cpp
===================================================================
--- src/Actions/MoleculeAction/CopyAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/CopyAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -20,4 +20,5 @@
 #include "CodePatterns/MemDebug.hpp"
 
+#include "Actions/UndoRedoHelpers.hpp"
 #include "CodePatterns/Log.hpp"
 #include "CodePatterns/Verbose.hpp"
@@ -31,4 +32,5 @@
 #include <fstream>
 #include <string>
+#include <vector>
 
 #include "Actions/MoleculeAction/CopyAction.hpp"
@@ -40,15 +42,19 @@
 #include "Action_impl_pre.hpp"
 /** =========== define the function ====================== */
-Action::state_ptr MoleculeCopyAction::performCall() {
-  molecule *copy = NULL;
+Action::state_ptr MoleculeCopyAction::performCall()
+{
+  std::vector<moleculeId_t> molecules;
+  for (World::MoleculeSelectionConstIterator iter = World::getInstance().beginMoleculeSelection();
+      iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    molecule * const copy = (iter->second)->CopyMolecule();
+    Vector *Center = (iter->second)->DetermineCenterOfAll();
+    *Center *= -1.;
+    *Center += params.position.get();
+    copy->Translate(Center);
+    delete(Center);
+    molecules.push_back(copy->getId());
+  }
 
-  copy = params.mol->CopyMolecule();
-  Vector *Center = params.mol->DetermineCenterOfAll();
-  *Center *= -1.;
-  *Center += params.position;
-  copy->Translate(Center);
-  delete(Center);
-
-  return Action::state_ptr(new MoleculeCopyState(copy,params));
+  return Action::state_ptr(new MoleculeCopyState(molecules,params));
 }
 
@@ -56,6 +62,5 @@
   MoleculeCopyState *state = assert_cast<MoleculeCopyState*>(_state.get());
 
-  state->copy->removeAtomsinMolecule();
-  World::getInstance().destroyMolecule(state->copy);
+  RemoveMoleculesWithAtomsByIds(state->copies);
 
   return Action::state_ptr(_state);
@@ -63,14 +68,5 @@
 
 Action::state_ptr MoleculeCopyAction::performRedo(Action::state_ptr _state){
-  MoleculeCopyState *state = assert_cast<MoleculeCopyState*>(_state.get());
-
-  molecule *copy = state->params.mol->CopyMolecule();
-  Vector *Center = state->params.mol->DetermineCenterOfAll();
-  *Center *= -1.;
-  *Center += state->params.position;
-  copy->Translate(Center);
-  delete(Center);
-
-  return Action::state_ptr(new MoleculeCopyState(copy,state->params));
+  return performCall();
 }
 
Index: src/Actions/MoleculeAction/CopyAction.def
===================================================================
--- src/Actions/MoleculeAction/CopyAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/CopyAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,17 +7,21 @@
 
 // all includes and forward declarations necessary for non-integral types below
-class MoleculeListClass;
+#include <vector>
+
+#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
 
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (const molecule *)(Vector)
-#define paramtokens ("copy-molecule")("position")
-#define paramdescriptions ("molecule to copy")("position in R^3 space")
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (Vector)
+#define paramtokens ("position")
+#define paramdescriptions ("position in R^3 space")
 #undef paramdefaults
-#define paramreferences (mol)(position)
+#define paramreferences (position)
+#define paramvalids \
+(BoxVectorValidator())
 
-#define statetypes (molecule *)
-#define statereferences (copy)
+#define statetypes (const std::vector<moleculeId_t>)
+#define statereferences (copies)
 
 // some defines for all the names, you may use ACTION, STATE and PARAMS
Index: src/Actions/MoleculeAction/FillVoidWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillVoidWithMoleculeAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/FillVoidWithMoleculeAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -46,22 +46,22 @@
 /** =========== define the function ====================== */
 Action::state_ptr MoleculeFillVoidWithMoleculeAction::performCall() {
-  if (!boost::filesystem::exists(params.fillername)) {
-    ELOG(1, "File with filler molecule " << params.fillername << " does not exist!");
+  if (!boost::filesystem::exists(params.fillername.get())) {
+    ELOG(1, "File with filler molecule " << params.fillername.get() << " does not exist!");
     return Action::failure;
   }
 
   LOG(1, "INFO: Filling Box with water molecules, "
-      << " minimum distance to molecules" << params.boundary
-      << ", random atom displacement " << params.RandAtomDisplacement
-      << ", random molecule displacement " << params.RandMoleculeDisplacement
-      << ", distances between fillers (" << params.distances[0] << "," << params.distances[1] << "," << params.distances[2]
-      << "), MinDistance " << params.MinDistance
-      << ", DoRotate " << params.DoRotate << ".");
+      << " minimum distance to molecules" << params.boundary.get()
+      << ", random atom displacement " << params.RandAtomDisplacement.get()
+      << ", random molecule displacement " << params.RandMoleculeDisplacement.get()
+      << ", distances between fillers (" << params.distances.get()[0] << "," << params.distances.get()[1] << "," << params.distances.get()[2]
+      << "), MinDistance " << params.MinDistance.get()
+      << ", DoRotate " << params.DoRotate.get() << ".");
   // construct water molecule
   std::vector<molecule *> presentmolecules = World::getInstance().getAllMolecules();
 //  LOG(0, presentmolecules.size() << " molecules initially are present.");
-  std::string FilenameSuffix = params.fillername.string().substr(params.fillername.string().find_last_of('.')+1, params.fillername.string().length());
+  std::string FilenameSuffix = params.fillername.get().string().substr(params.fillername.get().string().find_last_of('.')+1, params.fillername.get().string().length());
   ifstream input;
-  input.open(params.fillername.string().c_str());
+  input.open(params.fillername.get().string().c_str());
   ParserTypes type = FormatParserStorage::getInstance().getTypeFromSuffix(FilenameSuffix);
   FormatParserInterface &parser = FormatParserStorage::getInstance().get(type);
@@ -72,5 +72,5 @@
   ASSERT(filler != NULL,
       "MoleculeFillVoidWithMoleculeAction::performCall() - no last molecule found, nothing parsed?.");
-  filler->SetNameFromFilename(params.fillername.string().c_str());
+  filler->SetNameFromFilename(params.fillername.get().string().c_str());
   World::AtomComposite Set = filler->getAtomSet();
   World::getInstance().getBondGraph()->CreateAdjacency(Set);
@@ -79,14 +79,14 @@
   double distance[NDIM];
   for (int i=0;i<NDIM;i++)
-    distance[i] = params.distances[i];
+    distance[i] = params.distances.get()[i];
   FillVoidWithMolecule(
       filler,
       *(World::getInstance().getConfig()),
       distance,
-      params.boundary,
-      params.RandAtomDisplacement,
-      params.RandMoleculeDisplacement,
-      params.MinDistance,
-      params.DoRotate);
+      params.boundary.get(),
+      params.RandAtomDisplacement.get(),
+      params.RandMoleculeDisplacement.get(),
+      params.MinDistance.get(),
+      params.DoRotate.get());
 
   // generate list of newly created molecules
Index: src/Actions/MoleculeAction/FillVoidWithMoleculeAction.def
===================================================================
--- src/Actions/MoleculeAction/FillVoidWithMoleculeAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/FillVoidWithMoleculeAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -8,14 +8,29 @@
 // all includes and forward declarations necessary for non-integral types below
 #include "LinearAlgebra/Vector.hpp"
-class MoleculeListClass;
+
+#include "LinearAlgebra/defs.hpp"
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
+#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+#include "Parameters/Validators/Specific/ParserFileValidator.hpp"
 
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (boost::filesystem::path)(Vector)(double)(double)(double)(double)(bool)
 #define paramtokens ("fill-void")("distances")("distance-to-molecule")("random-atom-displacement")("random-molecule-displacement")("distance-to-boundary")("DoRotate")
 #define paramdescriptions ("name of xyz file of filler molecule")("list of three of distances in space, one for each axis direction")("minimum distance to present molecules")("magnitude of random atom displacement")("magnitude of random molecule displacement")("minimum distance to boundary")("whether to rotate or not")
-#define paramdefaults (NODEFAULT)(NODEFAULT)("0.")("0.")("0.")("0.")("0")
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(false))
 #define paramreferences (fillername)(distances)(boundary)(RandAtomDisplacement)(RandMoleculeDisplacement)(MinDistance)(DoRotate)
+#define paramvalids \
+(FilePresentValidator() && ParserFileValidator()) \
+(BoxVectorValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(DummyValidator< bool >())
 
 #define statetypes (std::vector<molecule *>)
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -46,18 +46,18 @@
 
   LOG(1, "INFO: Filling Box with water molecules, "
-      << " minimum distance to molecules" << params.boundary
-      << ", random atom displacement " << params.RandAtomDisplacement
-      << ", random molecule displacement " << params.RandMoleculeDisplacement
-      << ", distances between fillers (" << params.distances[0] << "," << params.distances[1] << "," << params.distances[2]
-      << "), MinDistance " << params.MaxDistance
-      << ", DoRotate " << params.DoRotate << ".");
+      << " minimum distance to molecules" << params.boundary.get()
+      << ", random atom displacement " << params.RandAtomDisplacement.get()
+      << ", random molecule displacement " << params.RandMoleculeDisplacement.get()
+      << ", distances between fillers (" << params.distances.get()[0] << "," << params.distances.get()[1] << "," << params.distances.get()[2]
+      << "), MinDistance " << params.MaxDistance.get()
+      << ", DoRotate " << params.DoRotate.get() << ".");
   // construct water molecule
   std::vector<molecule *> presentmolecules = World::getInstance().getAllMolecules();
 //  LOG(0, presentmolecules.size() << " molecules initially are present.");
-  std::string FilenameSuffix = params.fillername.string().substr(params.fillername.string().find_last_of('.')+1, params.fillername.string().length());
+  std::string FilenameSuffix = params.fillername.get().string().substr(params.fillername.get().string().find_last_of('.')+1, params.fillername.get().string().length());
   ifstream input;
-  LOG(0, "STATUS: Loading filler molecule " << params.fillername.string().c_str()
+  LOG(0, "STATUS: Loading filler molecule " << params.fillername.get().string().c_str()
       << " of suffix " << FilenameSuffix << ".");
-  input.open(params.fillername.string().c_str());
+  input.open(params.fillername.get().string().c_str());
   FormatParserStorage::getInstance().load(input, FilenameSuffix);
   input.close();
@@ -67,5 +67,5 @@
   ASSERT(filler != NULL,
       "MoleculeFillWithMoleculeAction::performCall() - no last molecule found, nothing parsed?.");
-  filler->SetNameFromFilename(params.fillername.string().c_str());
+  filler->SetNameFromFilename(params.fillername.get().string().c_str());
   World::AtomComposite Set = filler->getAtomSet();
   LOG(1, "INFO: The filler molecules has " << Set.size() << " atoms.");
@@ -78,14 +78,14 @@
   double distance[NDIM];
   for (int i=0;i<NDIM;i++)
-    distance[i] = params.distances[i];
+    distance[i] = params.distances.get()[i];
   FillBoxWithMolecule(
       World::getInstance().getMolecules(),
       filler, *(World::getInstance().getConfig()),
-      params.MaxDistance,
+      params.MaxDistance.get(),
       distance,
-      params.boundary,
-      params.RandAtomDisplacement,
-      params.RandMoleculeDisplacement,
-      params.DoRotate);
+      params.boundary.get(),
+      params.RandAtomDisplacement.get(),
+      params.RandMoleculeDisplacement.get(),
+      params.DoRotate.get());
   for (molecule::iterator iter = filler->begin(); !filler->empty(); iter = filler->begin()) {
     atom *Walker = *iter;
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.def
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -7,16 +7,33 @@
 
 // all includes and forward declarations necessary for non-integral types below
+#include <boost/assign.hpp>
 #include <boost/filesystem/path.hpp>
+#include <vector>
 #include "LinearAlgebra/Vector.hpp"
-class MoleculeListClass;
+
+#include "Parameters/Validators/DiscreteValidator.hpp"
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/Ops_Validator.hpp"
+#include "Parameters/Validators/Specific/BoxLengthValidator.hpp"
+#include "Parameters/Validators/Specific/BoxVectorValidator.hpp"
+#include "Parameters/Validators/Specific/FilePresentValidator.hpp"
+#include "Parameters/Validators/Specific/ParserFileValidator.hpp"
 
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
 #define paramtypes (boost::filesystem::path)(Vector)(double)(double)(double)(double)(bool)
 #define paramtokens ("fill-molecule")("distances")("distance-to-molecule")("random-atom-displacement")("random-molecule-displacement")("MaxDistance")("DoRotate")
 #define paramdescriptions ("name of xyz file of filler molecule")("list of three of distances in space, one for each axis direction")("minimum distance to present molecules")("magnitude of random atom displacement")("magnitude of random molecule displacement")("maximum spatial distance")("whether to rotate or not")
-#define paramdefaults (NODEFAULT)(NODEFAULT)("0.")("0.")("0.")("0.")("0")
+#define paramdefaults (NOPARAM_DEFAULT)(NOPARAM_DEFAULT)(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(0.))(PARAM_DEFAULT(false))
 #define paramreferences (fillername)(distances)(boundary)(RandAtomDisplacement)(RandMoleculeDisplacement)(MaxDistance)(DoRotate)
+#define paramvalids \
+(FilePresentValidator() && ParserFileValidator()) \
+(BoxVectorValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator()) \
+(BoxLengthValidator() || DiscreteValidator<double>(std::vector<double>(1,-1.))) \
+(DummyValidator< bool >())
 
 #define statetypes (std::vector<molecule *>)
Index: src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp
===================================================================
--- src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -43,9 +43,9 @@
 /** =========== define the function ====================== */
 Action::state_ptr MoleculeLinearInterpolationofTrajectoriesAction::performCall() {
-  LOG(0, "STATUS: Linear interpolation between configuration " << params.start << " and " << params.end << "." << endl);
-  ASSERT(params.end > params.start, "MoleculeLinearInterpolationofTrajectoriesAction() - start step greater than end step.");
+  LOG(0, "STATUS: Linear interpolation between configuration " << params.start.get() << " and " << params.end.get() << "." << endl);
+  ASSERT(params.end.get() > params.start.get(), "MoleculeLinearInterpolationofTrajectoriesAction() - start step greater than end step.");
   AtomSetMixin<std::vector<atom*> > set(World::getInstance().getSelectedAtoms());
-  LinearInterpolationBetweenSteps<std::vector<atom*> > LinearInterpolate(set,(unsigned int)(params.interpolation_steps));
-  LinearInterpolate(params.start, params.end, params.IdMapping);
+  LinearInterpolationBetweenSteps<std::vector<atom*> > LinearInterpolate(set,(unsigned int)(params.interpolation_steps.get()));
+  LinearInterpolate(params.start.get(), params.end.get(), params.IdMapping.get());
   LOG(0, "STATUS: done." << endl);
 
Index: src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.def
===================================================================
--- src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.def	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.def	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -9,12 +9,20 @@
 class MoleculeListClass;
 
+#include "Parameters/Validators/DummyValidator.hpp"
+#include "Parameters/Validators/GenericValidators.hpp"
+
 // i.e. there is an integer with variable name Z that can be found in
 // ValueStorage by the token "Z" -> first column: int, Z, "Z"
-// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
-#define paramtypes (int)(int)(int)(bool)
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#define paramtypes (unsigned int)(unsigned int)(unsigned int)(bool)
 #define paramtokens ("start-step")("interpolation-steps")("end-step")("id-mapping")
 #define paramdescriptions ("first or start step")("number of steps to interpolate in between start and end step")("last or end step")("whether the identity shall be used in mapping atoms onto atoms or not")
 #undef paramdefaults
 #define paramreferences (start)(interpolation_steps)(end)(IdMapping)
+#define paramvalids \
+(DummyValidator< unsigned int >()) \
+(NotZeroValidator< unsigned int >()) \
+(DummyValidator< unsigned int >()) \
+(DummyValidator< bool >())
 
 #undef statetypes
Index: src/Actions/MoleculeAction/LoadAction.cpp
===================================================================
--- src/Actions/MoleculeAction/LoadAction.cpp	(revision 004d5c87ea6293a9829cd1f88041c885baa3bb18)
+++ src/Actions/MoleculeAction/LoadAction.cpp	(revision bd81f9550d144dc810bf910fa44f3c8249361651)
@@ -44,6 +44,6 @@
 Action::state_ptr MoleculeLoadAction::performCall() {
   // parsing file if present
-  if (!boost::filesystem::exists(params.filename)) {
-    LOG(1, "Specified input file " << params.filename << " not found.");
+  if (!boost::filesystem::exists(params.filename.get())) {
+    LOG(1, "Specified input file " << params.filename.get() << " not found.");
     return Action::failure;
   } else {
@@ -53,12 +53,12 @@
     std::string FilenameSuffix;
     std::string FilenamePrefix;
-    if (params.filename.has_filename()) {
+    if (params.filename.get().has_filename()) {
       // get suffix
 #if BOOST_VERSION >= 104600
-      FilenameSuffix = params.filename.extension().string().substr(1); // remove the prefixed "."
-      FilenamePrefix = params.filename.stem().string();
+      FilenameSuffix = params.filename.get().extension().string().substr(1); // remove the prefixed "."
+      FilenamePrefix = params.filename.get().stem().string();
 #else
-      FilenameSuffix = params.filename.extension().substr(1); // remove the prefixed "."
-      FilenamePrefix = params.filename.stem();
+      FilenameSuffix = params.filename.get().extension().substr(1); // remove the prefixed "."
+      FilenamePrefix = params.filename.get().stem();
 #endif
     } else {
@@ -79,5 +79,5 @@
     // parse the file
     boost::filesystem::ifstream input;
-    input.open(params.filename);
+    input.open(params.filename.get());
     FormatParserStorage::getInstance().load(input, FilenameSuffix);
     input.close();
@@ -125,5 +125,5 @@
   // parse the file
   boost::filesystem::ifstream input;
-  input.open(state->params.filename);
+  input.open(state->params.filename.get());
   FormatParserStorage::getInstance().load(input, state->FilenameSuffix);
   input.close();
